SystemOrganization addCategory: #LightsOut!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'Angel 9/21/2012 13:47'!
initialize 
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff 
	! !

!LOCell methodsFor: 'accessing' stamp: 'Angel 9/21/2012 13:37'!
mouseAction: aBlock
	^mouseAction := aBlock ! !

!LOCell methodsFor: 'event handling' stamp: 'Angel 9/21/2012 13:40'!
mouseUp: anEvent
	mouseAction value ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 15:12'!
cellsPerSide
	"El numero de celdas a lo largo de cada lado del juego"
	^10! !

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 14:02'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 15:25'!
newCellAt: i at: j
	"Crea una celda en la posicion (i,j) y agrega esto a mi  representacion de pantalla en la posicion apropiada.
	Responde la nueva celda"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j-1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'Angel 9/21/2012 15:16'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState]! !
